local idstr_material = Idstring('material')
local idstr_contour_color = Idstring('contour_color')

Hooks:PostHook(ContourExt, 'add', 'IDM#27400_ContourExt_add',
function(self, type, sync, multiplier)
	if IDM._settings.mod_enabled and managers.groupai:state():whisper_mode() then
		if table.has(IDM.suspicion, self._unit:id()) then
			self:change_color(type, IDM:color_from_suspicion(IDM.suspicion[self._unit:id()].cumulative))
		elseif managers.enemy:is_civilian(self._unit) then
			self:change_color(type, Vector3(180, 60, 100) / 255)
		elseif self._unit:base() and self._unit:base().is_security_camera then
			self:change_color(type, Vector3(245, 245, 245) / 255)
		end
	end
end)

function ContourExt:replace_contour()
	if not self._contour_list or #self._contour_list == 0 then
		return
	end
	local setup = clone(self._contour_list[1])
	self:remove(setup.type, false)
	self:add(setup.type, false)
	self._contour_list[1].fadeout_t = setup.fadeout_t
end

function ContourExt:_upd_color(is_retry)
	if not self._contour_list or #self._contour_list == 0 then
		return
	end
	local color = self._contour_list[1].color or self._types[self._contour_list[1].type].color
	if not color then
		return
	end
	self._materials = self._materials or self._unit:get_objects_by_type(idstr_material)
	for _, material in ipairs(self._materials) do
		if not alive(material) then
			self:update_materials()
			if not is_retry then
				self:_upd_color(true)
			end
			break
		end
		material:set_variable(idstr_contour_color, color)
	end
	self:apply_to_linked('_upd_color', is_retry)
end